function [n,LP,i,Tcheck,T,tcount,p,clst,ccnt,compidx,compcnt,ecnt,elst,eidx,artverts,M2,vadj2,vidx2,el2,eadj2] = UDFS5(v,i,n,LP,Tcheck,T,tcount,p,el,vidx,vadj,clst,ccnt,eadj,N,compidx,compcnt,ecnt,elst,eidx,artverts,M2,vadj2,vidx2,el2,eadj2)
%produce list of unmapped vertices in a maximal biconnected component.
n(v)=i;
LP(v)=n(v);
i=i+1;
u=0;
for w=vidx(v)+1:vidx(v+1)
    q=vadj(w);
    e = eadj(w);
    if Tcheck(e)==0
        Tcheck(e)=1;
        tcount=tcount+1;
        T(tcount,1) = e;
    end
    if n(q)==0
        if u==0
            u=q; % q is the first child from v.
        end
        p(q) = v;
        [n,LP,i,Tcheck,T,tcount,p,clst,ccnt,compidx,compcnt,ecnt,elst,eidx,artverts,M2,vadj2,vidx2,el2,eadj2] = UDFS5(q,i,n,LP,Tcheck,T,tcount,p,el,vidx,vadj,clst,ccnt,eadj,N,compidx,compcnt,ecnt,elst,eidx,artverts,M2,vadj2,vidx2,el2,eadj2);
        if LP(q)>=n(v) %then block completed and v is an articulation vertex
            artverts=[artverts;v];
            if T(tcount)~=e %otherwise degenerate path of articulation vertices.
                vcheck = zeros(N,1);
                compcnt = compcnt+1;
                for k=tcount:-1:1
                    if vcheck(el(T(k),1))==0
                        vcheck(el(T(k),1))=1;
                        ccnt = ccnt+1;
                        clst(ccnt) = el(T(k),1);
                    end
                    if vcheck(el(T(k),2))==0
                        vcheck(el(T(k),2))=1;
                        ccnt = ccnt+1;
                        clst(ccnt) = el(T(k),2);
                    end
                    ecnt = ecnt+1;
                    elst(ecnt) = T(k);
                    tcount = tcount-1;
                    if T(k)==e
                        break;
                    end
                end
                eidx(compcnt+1) = ecnt;
                compidx(compcnt+1) = ccnt;
            else
                tcount=tcount-1;
            end
            if q==u && p(v)>0
               %update info.
               M2=M2+1;
               if q<p(v)
                  el2(M2,[1 2])=[q,p(v)];
               else
                  el2(M2,[1 2])=[p(v),q];
               end
               vadj2=[vadj2(1:vidx2(q+1));p(v);vadj2(vidx2(q+1)+1:end)];
               eadj2=[eadj2(1:vidx2(q+1));M2;eadj2(vidx2(q+1)+1:end)];
               vidx2(q+1:end)=vidx2(q+1:end)+1;
               vadj2=[vadj2(1:vidx2(p(v)+1));q;vadj2(vidx2(p(v)+1)+1:end)];
               eadj2=[eadj2(1:vidx2(p(v)+1));M2;eadj2(vidx2(p(v)+1)+1:end)];
               vidx2(p(v)+1:end)=vidx2(p(v)+1:end)+1;               
            end
            if q~=u
               M2=M2+1;
               if q<u
                  el2(M2,[1 2])=[q,u];
               else
                  el2(M2,[1 2])=[u,q];
               end
               vadj2=[vadj2(1:vidx2(q+1));u;vadj2(vidx2(q+1)+1:end)];
               eadj2=[eadj2(1:vidx2(q+1));M2;eadj2(vidx2(q+1)+1:end)];
               vidx2(q+1:end)=vidx2(q+1:end)+1;
               vadj2=[vadj2(1:vidx2(u+1));q;vadj2(vidx2(u+1)+1:end)];
               eadj2=[eadj2(1:vidx2(u+1));M2;eadj2(vidx2(u+1)+1:end)];
               vidx2(u+1:end)=vidx2(u+1:end)+1;           
            end
        end
        if LP(v)>LP(q)
            LP(v) = LP(q);
        end
    elseif q ~= p(v)
        if LP(v)>n(q)
            LP(v) = n(q);
        end
    end
end
end