function [ newcross,pathedge,pathedgeonce,paths,pdist,treecheck,newface,scheme,bigface_fails ] = Get_distances(dvadjm,Fidxm,Ndm,Sixidx,dualel,requiredimprovement,d,fin,incidente,deg,bad_edges,current_crossings_best,deadjm,merged_face_labels,max_F_index,scheme,bigface_depth,bigface_fails)

%do_outside_check = 1;
%bigface_depth = 0;
max_bigface_fails = 20;
consecutive_fails = 1;
use_c_gd2 = 0;

continue_looking = 1;

if scheme==1
    faces_of_interest = ones(max(deg(fin)),d);
    bad_face = zeros(max(deg(fin)),d);
    
    for i=1:d
        bad_face(deg(fin(i))+1:max(deg(fin)),i)=1;
        edge = incidente(fin(i));
        for j=1:deg(fin(i))
            if(bad_edges(edge))
                if(Sixidx(edge,1) == fin(i))
                    edge = Sixidx(edge,3);
                else
                    edge = Sixidx(edge,5);
                end
                bad_face(j,i) = 1;
                continue;
            end
            if(Sixidx(edge,1) == fin(i))
                faces_of_interest(j,i) = dualel(edge,1);
                edge = Sixidx(edge,3);
            else
                faces_of_interest(j,i) = dualel(edge,2);
                edge = Sixidx(edge,5);
            end
        end
    end
    [a,prev] = sp_bigface(dvadjm,Fidxm,max_F_index,Ndm,faces_of_interest.*(1-bad_face),d);
    a(merged_face_labels)=Ndm;
    [dist,face_choices] = min(a(faces_of_interest)+Ndm*bad_face);
    newcross = sum(dist);
    newface = max_F_index;
    
    if newcross+requiredimprovement < current_crossings_best
        continue_looking = 0;
        if consecutive_fails == 1
            bigface_fails = 0;
        end
        pdist = dist';
        paths = zeros(d,max(pdist)+1);
        if(max(pdist) > 0)
            pathedge = zeros(d,max(pdist));
        else
            pathedge = zeros(d,1);
        end
        
        pathedgeonce = zeros(max(deadjm),2);
        checked = zeros(Ndm,1);
        treecheck = 0;
        for i=1:d
            face = faces_of_interest(face_choices(i),i);
            paths(i,dist(i)+1) = face;
            if checked(face) && face ~= max_F_index
                treecheck=1;
            end
            checked(face)=1;
            for j=1:dist(i)
                face = prev(face);
                paths(i,dist(i)+1-j) = face;
                if checked(face) && face ~= max_F_index
                    treecheck=1;
                end
                checked(face)=1;
            end
            for j=1:dist(i)
                f1 = find(dvadjm(Fidxm(paths(i,j))+1:Fidxm(paths(i,j)+1)) == paths(i,j+1));
                for r=1:numel(f1)
                    if ~bad_edges(deadjm(Fidxm(paths(i,j))+f1(r)))
                        break
                    end
                end
                f1 = f1(r);
                if numel(f1)==0
                    disp('get distances error')
                    pause
                end
                pathedge(i,j) = deadjm(Fidxm(paths(i,j))+f1);
                pathedgeonce(deadjm(Fidxm(paths(i,j))+f1),1) = i;
                pathedgeonce(deadjm(Fidxm(paths(i,j))+f1),2) = j;
            end
        end
    end
    if(continue_looking && bigface_depth > 0)
        old_a = a;
        for faces=[1:max_F_index-1 max_F_index+1:Ndm]
            if(old_a(faces) <= bigface_depth )
                [a,prev] = sp_bigface(dvadjm,Fidxm,faces,Ndm,faces_of_interest.*(1-bad_face),d);
                a(merged_face_labels)=Ndm;
                [dist,face_choices] = min(a(faces_of_interest)+Ndm*bad_face);
                newcross = sum(dist);
                newface = faces;
                
                if newcross+requiredimprovement < current_crossings_best
                    
                    continue_looking = 0;
                    pdist = dist';
                    paths = zeros(d,max(pdist)+1);
                    if(max(pdist) > 0)
                        pathedge = zeros(d,max(pdist));
                    else
                        pathedge = zeros(d,1);
                    end
                    
                    pathedgeonce = zeros(max(deadjm),2);
                    checked = zeros(Ndm,1);
                    treecheck = 0;
                    for i=1:d
                        face = faces_of_interest(face_choices(i),i);
                        paths(i,dist(i)+1) = face;
                        if checked(face) && face ~= faces
                            treecheck=1;
                        end
                        checked(face)=1;
                        for j=1:dist(i)
                            face = prev(face);
                            paths(i,dist(i)+1-j) = face;
                            if checked(face) && face ~= faces
                                treecheck=1;
                            end
                            checked(face)=1;
                        end
                        for j=1:dist(i)
                            f1 = find(dvadjm(Fidxm(paths(i,j))+1:Fidxm(paths(i,j)+1)) == paths(i,j+1));
                            for r=1:numel(f1)
                                if ~bad_edges(deadjm(Fidxm(paths(i,j))+f1(r)))
                                    break
                                end
                            end
                            f1 = f1(r);
                            if numel(f1)==0
                                disp('stop')
                                pause
                            end
                            pathedge(i,j) = deadjm(Fidxm(paths(i,j))+f1);
                            pathedgeonce(deadjm(Fidxm(paths(i,j))+f1),1) = i;
                            pathedgeonce(deadjm(Fidxm(paths(i,j))+f1),2) = j;
                        end
                    end
                end
            end
            if(continue_looking == 0)
                break;
            end
        end
    end
    if(continue_looking == 1)
        bigface_fails = bigface_fails + 1;
        if(bigface_fails >= max_bigface_fails)
            scheme = 2;
        end    
    end
end
    


if(continue_looking)
    if(use_c_gd2 == 0)
        %vinc will have an arb. incident edge label to a vertex
        newlabel=Ndm+1;
        dist=zeros(d,newlabel);
        prev=zeros(d,newlabel);
        
        delv=zeros(d,max(deg(fin)));
        
        for k=1:d
            dvadj=dvadjm;
            Fidx=Fidxm;
            Nd=Ndm+1;
            curre=incidente(fin(k));
            while(bad_edges(curre))
                if Sixidx(curre,1)==fin(k)
                    curre = Sixidx(curre,3);
                else
                    curre = Sixidx(curre,5);
                end
            end
            
            if Sixidx(curre,1)==fin(k)
                nexte=Sixidx(curre,3);
            else
                nexte=Sixidx(curre,5);
            end
            
            while(bad_edges(nexte))
                if Sixidx(nexte,1)==fin(k)
                    nexte=Sixidx(nexte,3);
                else
                    nexte=Sixidx(nexte,5);
                end
            end
            
            curres = curre;
            nextes = nexte;
            
            for i=1:deg(fin(k))
                %contracting vertices in dual
                if Sixidx(curre,1)==fin(k)
                    fc=dualel(curre,1);
                else
                    fc=dualel(curre,2);
                end
                delv(k,i)=fc;
                curre=nexte;
                if Sixidx(curre,1)==fin(k)
                    nexte=Sixidx(curre,3);
                else
                    nexte=Sixidx(curre,5);
                end
                while(bad_edges(nexte))
                    if Sixidx(nexte,1)==fin(k)
                        nexte=Sixidx(nexte,3);
                    else
                        nexte=Sixidx(nexte,5);
                    end
                end
            end
            
            curre = curres;
            nexte = nextes;
            
            
            newv=[]; %degree of merged vertex - less than sum(incident dual verts)
            cnt=0;
            for i=1:deg(fin(k))
                %contracting vertices in dual
                if Sixidx(curre,1)==fin(k)
                    fc=dualel(curre,1);
                else
                    fc=dualel(curre,2);
                end
                delv(k,i)=fc;
                for j=Fidx(fc)+1:Fidx(fc+1)
                    q1=dvadj(j);
                    %if q1~=dualel(curre,2)  &&  q1~=dualel(nexte,1) && q1~=dualel(nexte,2) && q1~=dualel(curre,1) %assuming correct order in dualel vector
                    if(sum(delv(k,:)==q1) == 0)
                        cnt=cnt+1;
                        newv(cnt)=q1;
                        f1=[];
                        for r=Fidx(q1)+1:Fidx(q1+1)
                            if dvadj(r)==fc
                                f1=[f1,r];
                            end
                        end
                        dvadj(f1)=newlabel;
                        dvadj(j)=fc;
                        
                        
                    end
                end
                curre=nexte;
                if Sixidx(curre,1)==fin(k)
                    nexte=Sixidx(curre,3);
                else
                    nexte=Sixidx(curre,5);
                end
                while(bad_edges(nexte))
                    if Sixidx(nexte,1)==fin(k)
                        nexte=Sixidx(nexte,3);
                    else
                        nexte=Sixidx(nexte,5);
                    end
                end
            end
            
            %     for i=1:numel(Fidx)
            %         if sum(delv(k,:)==i)
            %             for x=1:size(delv,2)
            %             if sum(dvadj(Fidx(i)+1:Fidx(i+1))==delv(k,x))>0
            %                 i
            %                 dvadj(Fidx(i)+1:Fidx(i+1))
            %                 disp('thehv')
            %                 newlabel
            %                 delv
            %                 pause
            %             end
            %             end
            %         end
            %     end
            
            Fidx(newlabel+1)=Fidx(newlabel)+cnt;
            dvadj(end+1:end+cnt)=newv;
            % fin(k)
            % dvadj'
            % Fidx'
            %     delv
            %     dvadj'
            %     Fidx'
            %     pause
            %     pause
            %now the duel has a disconnected component. want newlabel as source, and
            %we also know the path to the end, except the last face, which we can
            %get from delv vector.
            
            %             fid = fopen('inputfile','w');
            %             fprintf(fid,[num2str(size(dvadj,1)) '\n']);
            %             fprintf(fid,[num2str(size(dvadj,2)) '\n']);
            %             for ci=1:size(dvadj,2)
            %                 for cj=1:size(dvadj,1)
            %                     fprintf(fid,[num2str(dvadj(cj,ci)) '\n']);
            %                 end
            %             end
            %             fprintf(fid,[num2str(size(Fidx,1)) '\n']);
            %             fprintf(fid,[num2str(size(Fidx,2)) '\n']);
            %             for ci=1:size(Fidx,2)
            %                 for cj=1:size(Fidx,1)
            %                     fprintf(fid,[num2str(Fidx(cj,ci)) '\n']);
            %                 end
            %             end
            %             fprintf(fid,[num2str(Nd) '\n']);
            %             fprintf(fid,[num2str(Nd) '\n']);
            %             fclose(fid);
            %             dos(['QC.exe inputfile outputfile']);
            %
            %             fid = fopen('outputfile','r');
            %
            %             line = fgetl(fid);
            %             rows = str2num(line);
            %             line = fgetl(fid);
            %             cols = str2num(line);
            %             %             rows
            %             %             cols
            %             cdist = zeros(rows,cols);
            %             for ci=1:cols
            %                 for cj=1:rows
            %                     cdist(cj,ci) = str2num(fgetl(fid));
            %                 end
            %             end
            %             line = fgetl(fid);
            %             rows = str2num(line);
            %             line = fgetl(fid);
            %             cols = str2num(line);
            %             cprev = zeros(rows,cols);
            %             for ci=1:cols
            %                 for cj=1:rows
            %                     cprev(cj,ci) = str2num(fgetl(fid));
            %                 end
            %             end
            %             fclose(fid);
            
            [dist(k,1:Nd),prev(k,1:Nd)]=sp_unweighted(dvadj,Fidx,Nd,Nd);
            
            %             dist(k,1:Nd)
            %             cdist
            %             if(sum(abs(dist(k,1:Nd) - cdist')) > 0)
            %                 dist(k,1:Nd)
            %                 cdist'
            %                 disp('dist different')
            %
            %                 pause;
            %             end
            %             if(sum(abs(prev(k,1:Nd) - cprev')) > 0)
            %                 prev(k,1:Nd)
            %                 cdist'
            %                 disp('prev different')
            %                 pause;
            %             end
            
            
        end
    else
        
        Nd = Ndm+1;
        [dist,prev,delv] = gd2(d,dvadjm,Fidxm,Ndm,incidente,bad_edges,fin,deg,dualel(:,1),dualel(:,2),Sixidx(:,1),Sixidx(:,3),Sixidx(:,5),max(deg(fin)),size(dualel,1));
        
        
    end
    dist(1:d,[merged_face_labels,Nd])=Nd;
    %     dist
    %     pause
    
    % for i=1:size(dist,1)
    %     for j=1:size(dist,2)
    %
    %     end
    % end
    % pause
    
    
    % dualel
    % delv
    % dist
    distsum=sum(dist);
    %distsum
    %find(distsum==0)
    %pause
    [newcross,newface]=min(distsum); % min and non-empty
    treecheck=0;
    % newface
    % dist
    % prev
    % delv
    
    if newcross+requiredimprovement < current_crossings_best
        checked=zeros(Nd,1);
        pdist=dist(:,newface);
        paths=zeros(d,max(pdist)+1);
        pathedge = zeros(d,1);
        pathedgeonce = zeros(max(deadjm),2);
        for k=1:d
            nn=newface;
            paths(k,1)=nn;
            
            %                 if checked(nn)
            %                     treecheck=1;
            %                 end
            %         checked(nn)=1;
            %         j=0;
            for j=1:pdist(k)-1
                nn=prev(k,nn);
                paths(k,j+1)=nn;  %dual vertex labels
                if checked(nn)
                    treecheck=1;
                end
                checked(nn)=1;
            end
            
            if(pdist(k) ~= 0)
                for r=1:numel(nonzeros(delv(k,:)))
                    tt=dvadjm(Fidxm(delv(k,r))+1:Fidxm(delv(k,r)+1));
                    pp=tt==paths(k,pdist(k));
                    if sum(pp)>0
                        %then this is the last face
                        paths(k,pdist(k)+1)=delv(k,r);
                        if checked(delv(k,r))
                            treecheck=1;
                        end
                        checked(delv(k,r))=1;
                        tt=deadjm(Fidxm(delv(k,r))+1:Fidxm(delv(k,r)+1));
                        pp=tt(pp);
                        pathedge(k,pdist(k))=pp(1);
                        pathedgeonce(pp(1),1) = k;
                        pathedgeonce(pp(1),2) = pdist(k);
                        break
                    end
                end
            end
        end
        %pathedge vector is now the edge crossed in G going from fi to fj
        %     paths=zeros(d,max(pdist));
        %     pathedge = zeros(d,1);
        %     pathedgeonce = zeros(max(deadjm),2);
        if(max(pdist)>0)
            for k=1:d
                for j=1:pdist(k)-1
                    %                 for r=1:size(dualel,1)  % better than lookup matrix
                    %                     if ~bad_edges(r)
                    %                         if (dualel(r,1)==paths(k,j) && dualel(r,2)==paths(k,j+1)) || (dualel(r,2)==paths(k,j) && dualel(r,1)==paths(k,j+1))
                    %                             pathedge(k,j)=r;
                    %                             break
                    %                         end
                    %                     end
                    %                 end
                    tt=dvadjm(Fidxm(paths(k,j))+1:Fidxm(paths(k,j)+1))==paths(k,j+1);
                    ttt=deadjm(Fidxm(paths(k,j))+1:Fidxm(paths(k,j)+1));
                    pp=ttt(tt);
                    pathedge(k,j)=pp(1);
                    pathedgeonce(pp(1),1) = k;
                    pathedgeonce(pp(1),2) = j;
                    %                 pathedge(k,j)=deadjm(Fidx(paths(k,j))+f1(1));
                    %                 pathedgeonce(deadjm(Fidx(paths(k,j))+f1(1)),1) = k;
                    %                 pathedgeonce(deadjm(Fidx(paths(k,j))+f1(1)),2) = j;
                end
            end
        end
    else
        paths=[];
        pathedge=[];
        pathedgeonce=[];
        pdist=[];
    end
end

end