function [ newcross,pathedge,pathedgeonce,paths,pdist,treecheck,newface ] = Get_distances_planarembedding(dvadjm,Fidxm,Ndm,Sixidx,dualel,d,fin,incidente,deg,deadjm)
%no bad_faces or merged_face_labels
    newlabel=Ndm+1;
    dist=zeros(d,newlabel);
    prev=zeros(d,newlabel);

    delv=zeros(d,max(deg(fin)));
    %fill out delv first
    for k=1:d
        dvadj=dvadjm;
        Fidx=Fidxm;
        Nd=Ndm+1;
        curre=incidente(fin(k));
        if Sixidx(curre,1)==fin(k)
            nexte=Sixidx(curre,3);
        else
            nexte=Sixidx(curre,5);
        end
    curres=curre;
    nextes=nexte;
        newv=zeros(size(dualel,1),1);
        cnt=0;
        count=0;
        while 1
            count=count+1;
            if Sixidx(curre,1)==fin(k)
                fc=dualel(curre,1);
                curre=Sixidx(curre,3);
            else
                fc=dualel(curre,2);
                curre=Sixidx(curre,5);
            end
            delv(k,count)=fc;
            if curre==curres
                break
            end
        end
        curre=curres;
       
        for i=1:deg(fin(k))
            if Sixidx(curre,1)==fin(k)
                fc=dualel(curre,1);
            else
                fc=dualel(curre,2);
            end
           for j=Fidx(fc)+1:Fidx(fc+1)
               q1=dvadj(j);
               if sum(delv(k,:)==q1)==0
                   cnt=cnt+1;
                   newv(cnt)=q1;
                   for r=Fidx(q1)+1:Fidx(q1+1)
                       if dvadj(r)==fc
                           %                             f1=[f1,r];
                           dvadj(r)=newlabel;
                       end
                   end
                   dvadj(j)=fc;
               end
           end
            if Sixidx(curre,1)==fin(k)
                curre=Sixidx(curre,3);
            else
                curre=Sixidx(curre,5);
            end
            if curre==curres
                break
            end
        end
        Fidx(newlabel+1)=Fidx(newlabel)+cnt;
        dvadj(end+1:end+cnt)=newv(1:cnt);
        %now the duel has a disconnected component. want newlabel as source, and
        %we also know the path to the end, except the last face, which we can
        %get from delv vector.
        %[dist(k,1:Nd),prev(k,1:Nd)]=sp_unweighted(dvadj,Fidx,Nd,Nd);
        [dist(k,1:Nd),prev(k,1:Nd)]=sp(dvadj,Fidx,Nd,Nd);
    end
    dist(1:d,Nd)=Nd;
    if d>1
    distsum=sum(dist);
    else
        distsum=dist;
    end
    [newcross,newface]=min(distsum); % min and non-empty
    treecheck=0;
    
        checked=zeros(Nd,1);
        pdist=dist(:,newface);
        paths=zeros(d,max(pdist)+1);
        pathedge = zeros(d,max(max(pdist),2));
        pathedgeonce = zeros(size(dualel,1),2);
        for k=1:d
            nn=newface;
            paths(k,1)=nn;
            for j=1:pdist(k)-1
                nn=prev(k,nn);
                paths(k,j+1)=nn;  %dual vertex labels
                if checked(nn)
                    treecheck=1;
                end
                checked(nn)=1;
            end
            
            if(pdist(k) ~= 0)
                for r=1:numel(nonzeros(delv(k,:)))
                    tt=dvadjm(Fidxm(delv(k,r))+1:Fidxm(delv(k,r)+1));
                    pp=tt==paths(k,pdist(k));
                    if sum(pp)>0
                        %then this is the last face
                        paths(k,pdist(k)+1)=delv(k,r);
                        if checked(delv(k,r))
                            treecheck=1;
                        end
                        checked(delv(k,r))=1;
                        tt=deadjm(Fidxm(delv(k,r))+1:Fidxm(delv(k,r)+1));
                        pp=tt(pp);
                        pathedge(k,pdist(k))=pp(1);
                        pathedgeonce(pp(1),1) = k;
                        pathedgeonce(pp(1),2) = pdist(k);
                        break
                    end
                end
            end
        end
        %pathedge vector is now the edge crossed in G going from fi to fj
        if(max(pdist)>0)
            for k=1:d
                for j=1:pdist(k)-1
                    tt=dvadjm(Fidxm(paths(k,j))+1:Fidxm(paths(k,j)+1))==paths(k,j+1);
                    ttt=deadjm(Fidxm(paths(k,j))+1:Fidxm(paths(k,j)+1));
                    pp=ttt(tt);
                    pathedge(k,j)=pp(1);
                    pathedgeonce(pp(1),1) = k;
                    pathedgeonce(pp(1),2) = j;
                end
            end
        end




end

