function [ Sixidx,Clabel,Dlabel,Cidx ] = New_clabel( treechk,pathedge,pathedgeonce,paths,Sixidx_plan,fin,fi,Clabel,Dlabel,Cidx,F,Fdir,pdist,M,d,incidente,vm,elist,eidx,Fidx,Md,newface,Sixidx,origedgelabel,origedgeorder,rf_map)

if treechk
    %build paths_tree
    [ comb_ancestor_sparse,comb_ancestor_first,comb_ancestor_next,eparent,vparent,comb_count ] = paths_tree( Md,pathedge,paths,Sixidx_plan,fin,d,F,Fdir,Fidx,pdist );
end
mnofi=1:M;
mnofi(fi)=[];
fi_check = zeros(M,1);
fi_check(fi) = 1;

%remove clabel for old fi edges
for i=1:d
    Clabel=[Clabel(1:Cidx(fi(i)));Clabel(Cidx(fi(i)+1)+1:end)];
    Dlabel=[Dlabel(1:Cidx(fi(i)));Dlabel(Cidx(fi(i)+1)+1:end)];
    
    chnge=-(Cidx(fi(i)+1)-Cidx(fi(i)));
    Cidx(fi(i)+1:M+1)=Cidx(fi(i)+1:M+1)+chnge;
end
newClabel = [];
newDlabel = [];
newCidx = zeros(length(Cidx),1);
last_i = 0;
for i=mnofi
    q=elist(eidx(i)+1:eidx(i+1));
    qn=eidx(i+1)-eidx(i);
    ctemp = zeros(qn,1);
    dtemp = zeros(qn,1);
    ctempcount = 0;
    dtempcount = 0;
    for j=1:qn %vertices now not in order, so may need extra check of Sixidx
        if treechk && comb_count(q(j)) %epar is a check as to whether edge is involved in paths_tree
            [ ordr ] = traverse_paths_tree( eparent,vparent,comb_ancestor_sparse,comb_ancestor_first,comb_ancestor_next,comb_count,q(j),Md,fin,pathedge,fi );
            %ordr needs changed to match the the direction of parent edge.
            [x1,y1]=find(pathedge==q(j));
            samechk = 1;
            same=1;
            if origedgeorder(q(j))==1 || origedgeorder(q(j))==eidx(origedgelabel(q(j))+1)-eidx(origedgelabel(q(j)))
                if Sixidx(origedgelabel(q(j)),1)~=Sixidx_plan(q(j),1) && Sixidx(origedgelabel(q(j)),2)~=Sixidx_plan(q(j),2)
                    same=0;
                end
            else
                backe=elist(eidx(origedgelabel(q(j)))+origedgeorder(q(j))-1);
                if sum(Sixidx_plan(backe,[1 2])==Sixidx_plan(q(j),1))==0
                    same=0;
                end
            end
             
            epos=find(F(Fidx(paths(x1(1),y1(1)+1))+1:Fidx(paths(x1(1),y1(1)+1)+1))==q(j));
            if Fdir(Fidx(paths(x1(1),y1(1)+1))+epos)==1
                if same
                    samechk = 0;
                    ordr=ordr(end:-1:1);
                end
            else
                if ~same
                    samechk = 0;
                    ordr=ordr(end:-1:1);
                end
            end
            ctemp(ctempcount+1:ctempcount+length(ordr),1) = ordr;
            ctempcount = ctempcount + length(ordr);
            if samechk == 1
                for k=1:numel(ordr)
                    %find crossing orientation
                    f1=fi==ordr(k);
                    [ ori ] = new_crossing_orientation(F(Fidx(paths(x1(k),y1(k)+1))+1:Fidx(paths(x1(k),y1(k)+1)+1)),q(j),origedgelabel(q(j)),vm,fin(f1),Sixidx_plan,elist,eidx,origedgeorder);
                    if(length(ori) ~= 1)
                        disp('length of ori not one')
                        pause;
                    end
                    dtempcount = dtempcount+1;
                    dtemp(dtempcount,1) = ori;
                end
            else
                 for k=1:numel(ordr)
                    %find crossing orientation
                    f1=fi==ordr(k);
                    [ ori ] = new_crossing_orientation(F(Fidx(paths(x1(numel(x1)+1-k),y1(numel(x1)+1-k)+1))+1:Fidx(paths(x1(numel(x1)+1-k),y1(numel(x1)+1-k)+1)+1)),q(j),origedgelabel(q(j)),vm,fin(f1),Sixidx_plan,elist,eidx,origedgeorder);
                    if(length(ori) ~= 1)
                        disp('length of ori not one')
                        pause;
                    end
                    dtempcount = dtempcount+1;
                    dtemp(dtempcount,1) = ori;
                    
                end
            end
            
        else
            x1 = pathedgeonce(q(j),1);
            y1 = pathedgeonce(q(j),2);
            if(x1 ~= 0)
                ctempcount = ctempcount + 1;
                ctemp(ctempcount,1) = fi(x1);
                %find crossing orientation
                [ ori ] = new_crossing_orientation(F(Fidx(paths(x1,y1+1))+1:Fidx(paths(x1,y1+1)+1)),q(j),origedgelabel(q(j)),vm,fin(x1),Sixidx_plan,elist,eidx,origedgeorder);
                dtempcount = dtempcount + 1;
                dtemp(dtempcount,1) = ori;
            end
        end
        if j<qn && fi_check(Clabel(Cidx(i)+j))==0 %replace with bad_edge check
            ctempcount = ctempcount + 1;
            ctemp(ctempcount,1) = Clabel(Cidx(i)+j);
 
            dtempcount = dtempcount + 1;
            dtemp(dtempcount,1) = Dlabel(Cidx(i)+j);
        end
    end

    if numel(ctemp)-numel(dtemp)~=0
        disp('Clabel ctemp dtemp different length')
        pause
    end
    if(ctempcount ~= 0)
        newClabel = [newClabel;ctemp(1:ctempcount)];
    end
    if(dtempcount ~= 0)
        newDlabel = [newDlabel;dtemp(1:dtempcount)];
    end
    if(last_i ~= 0)
        newCidx(last_i+2:i) = newCidx(last_i+1);
    end
    last_i = i;
    newCidx(i+1) = newCidx(i) + ctempcount;
    if i~=M
    newCidx(i+2:M+1)=newCidx(i+1);
    end
end
Clabel = newClabel;
Dlabel = newDlabel;
Cidx = newCidx;
newf=F(Fidx(newface)+1:Fidx(newface+1));
nf=Fidx(newface+1)-Fidx(newface);
newd=Fdir(Fidx(newface)+1:Fidx(newface+1));
%clockwise order of edge around vm in the new location of vm.
fincheck=zeros(d,1);
atemp=[];
%removing fi edges from sixidx.
for i=1:d
    if Sixidx(fi(i),1)==vm
        ec=Sixidx(fi(i),5);
        if Sixidx(ec,1)==fin(i)
            Sixidx(ec,4)=Sixidx(fi(i),6);
        else
            
            Sixidx(ec,6)=Sixidx(fi(i),6);
        end
        ec=Sixidx(fi(i),6);
        if Sixidx(ec,1)==fin(i)
            Sixidx(ec,3)=Sixidx(fi(i),5);
        else
            Sixidx(ec,5)=Sixidx(fi(i),5);
        end
    else
        ec=Sixidx(fi(i),3);
        if Sixidx(ec,1)==fin(i)
            Sixidx(ec,4)=Sixidx(fi(i),4);
        else
            Sixidx(ec,6)=Sixidx(fi(i),4);
        end
        ec=Sixidx(fi(i),4);
        if Sixidx(ec,1)==fin(i)
            
            Sixidx(ec,3)=Sixidx(fi(i),3);
        else
            
            Sixidx(ec,5)=Sixidx(fi(i),3);
        end
    end
end
for i=1:nf
    if newd(i)==1
        vstart=Sixidx_plan(newf(i),1);
    else
        vstart=Sixidx_plan(newf(i),2);
    end
    q=fin==vstart;
    if sum(q) && fincheck(q)==0
        atemp=[atemp;fi(q)];
        fincheck(q)=1;
        %tells us which edge the new fi ones get inserted between for edge ending in newface.
        %scan around and update sixidx for this vertex
        curre=fi(q);
        if Sixidx(origedgelabel(curre),1)==fin(q) %%%%%these are old sixidx without vm in them%%%%%%%%%oo
            
            Sixidx(origedgelabel(curre),[3 4])=[origedgelabel(newf(mod(i-2,nf)+1)),origedgelabel(newf(i))];
        else
            
            Sixidx(origedgelabel(curre),[5 6])=[origedgelabel(newf(mod(i-2,nf)+1)),origedgelabel(newf(i))];
        end
        if Sixidx(origedgelabel(newf(i)),1)==fin(q)
            
            Sixidx(origedgelabel(newf(i)),3)=fi(q);
        else
            
            Sixidx(origedgelabel(newf(i)),5)=fi(q);
        end
        if Sixidx(origedgelabel(newf(mod(i-2,nf)+1)),1)==fin(q)
            
            Sixidx(origedgelabel(newf(mod(i-2,nf)+1)),4)=fi(q);
        else
            
            Sixidx(origedgelabel(newf(mod(i-2,nf)+1)),6)=fi(q);
        end
    end
    x1=pathedge(:,1)==newf(i);
    if sum(x1)>1
        [ ordr ] = traverse_paths_tree( eparent,vparent,comb_ancestor_sparse,comb_ancestor_first,comb_ancestor_next,comb_count,newf(i),Md,fin,pathedge,fi );
        atemp=[atemp;ordr];
        
    elseif sum(x1)==1
        atemp=[atemp;fi(x1)];
    end
end
for i=1:d
    if i==1
        bs=atemp(end);
    else
        bs=atemp(i-1);
    end
    if i==d
        fs=atemp(1);
    else
        fs=atemp(i+1);
    end
    if Sixidx(atemp(i),1)==vm
        
        Sixidx(atemp(i),[3,4])= [fs,bs];
    else
        
        Sixidx(atemp(i),[5,6])= [fs,bs];
    end
end
%clabel of new fi edges.
for i=1:d
    if pdist(i)
        tplan=pathedge(i,1:pdist(i));
        t=origedgelabel(tplan);
        if vm>fin(i)
            tplan=tplan(end:-1:1);
            t=t(end:-1:1);
        end
        chnge=numel(t);
        Clabel=[Clabel(1:Cidx(fi(i)));t;Clabel(Cidx(fi(i)+1)+1:end)];
        Dlabel=[Dlabel(1:Cidx(fi(i)));t;Dlabel(Cidx(fi(i)+1)+1:end)];
       
        Cidx((fi(i)+1):end)=Cidx((fi(i)+1):end)+chnge;
        checked=zeros(pdist(i),1);
        for j=1:numel(t)
            f1=find(t==t(j));
            if numel(f1)>1 && checked(j)==0
                %then multi-crossed edge
                checked(f1)=1;
                newedgelabel=tplan(f1);
                [~,idxe]=sort(newedgelabel);
                f2=find(Clabel(Cidx(t(j))+1:Cidx(t(j)+1))==fi(i));
                Dlabel(Cidx(fi(i))+f1(idxe))=-Dlabel(Cidx(t(j))+f2);
            elseif numel(f1)==1
                f2=find(Clabel(Cidx(t(j))+1:Cidx(t(j)+1))==fi(i));
                Dlabel(Cidx(fi(i))+j)=-Dlabel(Cidx(t(j))+f2);
            end
        end
    end
    
end
checked=zeros(d,1);
endfaces=zeros(d,1);
for i=1:d
    endfaces(i)=paths(i,pdist(i)+1);
end
for rr=1:d
 
    if checked(rr)==0
        checked(endfaces==endfaces(rr))=1;
        if pdist(rr)~=0 %then current new edge does not end in same face as vm.
            
            dq=nonzeros(pathedge(rr,1:pdist(rr)));
            startedge=dq(end);
            facee=endfaces(rr);
            q=F(Fidx(facee)+1:Fidx(facee+1));
            if treechk && comb_count(startedge)  %then we must have created a tree 
                [ ctemp2 ] = traverse_paths_tree( eparent,vparent,comb_ancestor_sparse,comb_ancestor_first,comb_ancestor_next,comb_count,startedge,Md,fin,pathedge,fi );
            else
                ctemp2=fi(rr);
            end
            count=1;
            fs=find(q==startedge);
            fn=Fidx(facee+1)-Fidx(facee);
            dd=Fdir(Fidx(facee)+1:Fidx(facee+1));
            fstep=[2:fn,1];
            
            for i=1:fn
                fs=fstep(fs);
                if dd(fs)==1
                    vstart=Sixidx_plan(q(fs),1);
                else
                    vstart=Sixidx_plan(q(fs),2);
                end
                if sum(fin==vstart)>0 && endfaces(fin==vstart,1)==facee
                    %then this path does end via this face
                    if ctemp2(count)==fi(fin==vstart)
                        count=count+1;
                        %then scan and update this vertex
                        if Sixidx(fi(fin==vstart),1)==vstart
                            
                            Sixidx(fi(fin==vstart),[3 4])=[origedgelabel(q(mod(fs-2,fn)+1)),origedgelabel(q(fs))];
                        else
                            
                            Sixidx(fi(fin==vstart),[5 6])=[origedgelabel(q(mod(fs-2,fn)+1)),origedgelabel(q(fs))];
                        end
                        if Sixidx(origedgelabel(q(fs)),1)==vstart
                          
                            Sixidx(origedgelabel(q(fs)),3)=fi(fin==vstart);
                        else
                             
                            Sixidx(origedgelabel(q(fs)),5)=fi(fin==vstart);
                        end
                        if Sixidx(origedgelabel(q(mod(fs-2,fn)+1)),1)==vstart
                             
                            Sixidx(origedgelabel(q(mod(fs-2,fn)+1)),4)=fi(fin==vstart);
                        else
                           
                            Sixidx(origedgelabel(q(mod(fs-2,fn)+1)),6)=fi(fin==vstart);
                        end
                    end
                end
                ss=sum(sum(pathedge==q(fs)));
                if ss>0 && q(fs)~=startedge

                    count=count+ss;
                end
                if count>numel(ctemp2)
                    break
                end
                
            end
        end
    end
end






end

