function [ current_crossings,Clabel,Cidx,M ] = Quick_cross_main_loop( incidente,Sixidx,Clabel,Dlabel,Cidx,N,M,deg,current_crossings,min_scheme,bigface_depth,orig_N,verbosity )
old_version = 0;
iters=0;
vm_best=0;
bigface_fails = 0;
if verbosity>0
    disp(['Component start crossings:  ',num2str(current_crossings)])
end
while 1
    current_crossings_best=current_crossings;
    iters=iters+1;
    improvementfound=0;
    [Sixidx_plan,~,elist,eidx,~,M_plan,origedgelabel,origedgeorder,incidente_plan ] = Planarise_Sixidx( Sixidx,Clabel,Cidx,Dlabel,N,M );
    bad_edges = zeros(M_plan,1);
    [F,Fidx,Fdir,dvadj,ddeg,dualel,Nd,deadj]=Faces(Sixidx_plan,M_plan,[],bad_edges);
%     verts=randperm(N);
     verts=[vm_best+1:N,1:vm_best];
    for vm=verts
        d=deg(vm);
        fin=zeros(d,1);
        fi=zeros(d,1);
        fi(1)=incidente(vm);
        if Sixidx(fi(1),1)==vm
            fin(1)=Sixidx(fi(1),2);
        else
            fin(1)=Sixidx(fi(1),1);
        end
        for i=2:d
            if Sixidx(fi(i-1),1)==vm
                fi(i)=Sixidx(fi(i-1),3);
            else
                fi(i)=Sixidx(fi(i-1),5);
            end
            if Sixidx(fi(i),1)==vm
                fin(i)=Sixidx(fi(i),2);
            else
                fin(i)=Sixidx(fi(i),1);
            end
        end
        bad_edge_labels=zeros(1,sum(eidx(fi(1:d)+1)-eidx(fi(1:d))));
        bad_edges=zeros(M_plan,1);
        cnt1=0;
        for i=1:d
            bad_edges(elist(eidx(fi(i))+1:eidx(fi(i)+1)))=1;
            bad_edge_labels(cnt1+1:cnt1+eidx(fi(i)+1)-eidx(fi(i)))=elist(eidx(fi(i))+1:eidx(fi(i)+1));
            cnt1=cnt1+eidx(fi(i)+1)-eidx(fi(i));
        end
        requiredimprovement=current_crossings;
        for i=1:d
            for j=Cidx(fi(i))+1:Cidx(fi(i)+1)
                if sum(fi==Clabel(j))==0
                    requiredimprovement=requiredimprovement-1;
                else
                    if fi(i)>Clabel(j)
                        requiredimprovement=requiredimprovement-1;
                    end
                end
            end
        end
        [ newdvadj,newfidx,newdualel,pooledgemap,merged_face_labels,newNd,~,neweadj,maxFindex ] = merge_dual( Nd,Fidx,dualel,M_plan,bad_edges,dvadj,ddeg,deadj,bad_edge_labels );
        [ newcross,pathedge,pathedgeonce,paths,pdist,treecheck,newface,min_scheme,bigface_fails ] = Get_distances(newdvadj,newfidx,newNd,Sixidx_plan,newdualel,requiredimprovement,d,...
            fin,incidente_plan,deg,bad_edges,current_crossings_best,neweadj,merged_face_labels,maxFindex,min_scheme,bigface_depth,bigface_fails);
        if requiredimprovement+newcross<current_crossings_best
            current_crossings_best=requiredimprovement+newcross;
            improvementfound=1;
            vm_best=vm;
            treecheck_best=treecheck;
            pathedge_best=pathedge;
            pathedgeonce_best = pathedgeonce;
            paths_best=paths;
            pdist_best=pdist;
            fin_best=fin;
            fi_best=fi;
            bad_edges_best=bad_edges;
            dualel_best=newdualel;
            newface_best=newface;
            d_best = d;
            pooledgemap_best=pooledgemap;
            if(min_scheme < 3)
                break;
            end
        end
    end
    
    if improvementfound
        
        [ newf_best,newfidx_best,newdir_best,rf_map_best ] = find_merge_faces( Nd,F,Fdir,Fidx,dualel_best,bad_edges_best,paths_best,pdist_best,d_best,Nd,pooledgemap_best);
        current_crossings=current_crossings_best;
        for i=1:d_best
            for j=1:pdist_best(i)+1
                paths_best(i,j)=rf_map_best(paths_best(i,j)); %map to 'relevant faces' vector labels, instead of merged dual labels.
            end
        end
        newface_best=rf_map_best(newface_best);
        
        [ Sixidx,Clabel,Dlabel,Cidx ] = New_clabel( treecheck_best,pathedge_best,pathedgeonce_best,paths_best,Sixidx_plan,fin_best,fi_best,Clabel,...
            Dlabel,Cidx,newf_best,newdir_best,pdist_best,M,d_best,incidente,vm_best,elist,eidx,newfidx_best,M_plan,newface_best,Sixidx,origedgelabel,origedgeorder,rf_map_best);
        if verbosity>0
            disp(['moved vertex: ',num2str(vm_best),' curr. crossings: ',num2str(current_crossings)]);
        end
        [ current_crossings,Sixidx,Clabel,Dlabel,Cidx,N,M,incidente,deg,vm_best ] = Subd_try( current_crossings,Sixidx,Clabel,Dlabel,Cidx,pathedge_best,...
            N,M,origedgelabel,incidente,deg,pdist_best,fi_best,fin_best,vm_best,orig_N,0 );

        
    else
        if verbosity>0
            disp(['Component finished crossings:  ',num2str(current_crossings)])
        end
        break
    end
end
%%%% uncomment for final drawing - requires boost graph library (MATLAB BGL)%%%%
%  [Sixidx_plan,planvlabels,elist,eidx,N_plan,M_plan,origedgelabel,origedgeorder,incidente_plan ] = Planarise_Sixidx( Sixidx,Clabel,Cidx,Dlabel,N,M );
%   ap=sparse_el_to_ajd(Sixidx_plan(:,[1,2]));
%       X = chrobak_payne_straight_line_drawing(ap);
%       gplot(ap,X,'.-');
%       hold on;
%       plot(X(N+1:end,1),X(N+1:end,2),'o','MarkerSize',2,...
%     'MarkerEdgeColor','red',...
%     'MarkerFaceColor',[1 .6 .6]);
%  plot(X(1:N,1),X(1:N,2),'o','MarkerSize',8,'MarkerEdgeColor','white','MarkerFaceColor','black');
end

