function [ A3 ] = graph_cartesian_product(A1,A2 )
%takes two graph adjacency matrices and creates their cartesian product.
n1=size(A1,1);
n2=size(A2,1);
A3=zeros(n1*n2);

for i=1:n1
    for j=1:n2
        for k=1:n1
            for l=1:n2
                if i==k
                    if A2(j,l)>0
                        A3((i-1)*n2+j,(k-1)*n2+l)=1;
                        A3((k-1)*n2+l,(i-1)*n2+j)=1;
                    end
                end
                if j==l
                     if A1(i,k)>0
                        A3((i-1)*n2+j,(k-1)*n2+l)=1;
                        A3((k-1)*n2+l,(i-1)*n2+j)=1;
                    end
                end
            end
        end
    end
end

end

