function [EL,L,lcnt,planar,alpha] = Strongly_planar4(e0,backedge,p2,neweadj,newvadj,newel,M,N,newdeg,LP2,first_cycle,alpha)

L=[];
EL=[];
lcnt=0;
%find spine path of segment S(e0) w(r+1),...,wk
planar=1;
if backedge(e0)==0
    x=newel(e0,1);
    y=newel(e0,2);
else
    x=newel(e0,2);
    y=newel(e0,1);
end
Spinepath=[];
currv = y;
curre = e0;
scnt = 0;

if backedge(e0)==0
    for i=1:M
        if backedge(curre)==1
            w0 = currv;
            break;
        end
        scnt = scnt + 1;
        Spinepath(scnt) = currv;
        curre = neweadj(currv,1);
        currv = newvadj(currv,1);
    end
else
    curre=e0;
    w0 = y;
end
L=w0;
lcnt=1;

%count the other tree verts from wo,...,w_r = x
currv=x;
w1=y;
cnt=0;
% treepath=[];
% end
for i=1:M
    if currv == w0
%         treepath=treepath(1:cnt-1);
        break
    end
    w1 = currv;
    currv = p2(currv);
    cnt = cnt+1;
%     treepath(1,cnt) = currv;
end
% total number of verts from wo,...,wk:

B=zeros(N,1);
h=0;
Alefts=zeros(N,1);
Arights=zeros(N,1);
Elefts=zeros(N,1);
Erights=zeros(N,1);
alcnt=zeros(N,1);
arcnt=zeros(N,1);
elcnt=zeros(N,1);
ercnt=zeros(N,1);
cnt2=0;
%   Spinepath
% pause
for j = scnt:-1:1
    cnt2 = cnt2+1;
    wj = Spinepath(j);
    indices=2:newdeg(wj);
    
    for r=indices
        ej=neweadj(wj,r);
        %then recurse on that segment
        [Ee,Ae,~,planar,alpha] = Strongly_planar4(ej,backedge,p2,neweadj,newvadj,newel,M,N,newdeg,LP2,first_cycle,alpha);
        if planar==0
            return;
        end
        if numel(Ae)==0
            L=[];
            planar=1;
            return;
        end
%         Ae
%         Arights
%                 wj
%                 pause
                
        if backedge(ej)==1
            loz = newvadj(wj,r);
        else
            loz = LP2(newvadj(wj,r));
        end
        [ h,Alefts,alcnt,Arights,arcnt,planar,Elefts,Erights,elcnt,ercnt] = segment_bipartite4( h,loz,Alefts,alcnt,Arights,arcnt,Ae,wj,Elefts,Erights,Ee,elcnt,ercnt);
        %         Alefts(1:6,:)
%         Arights(1:6,:)
%         disp('afterbip')
%         pause
        if planar==0
            return;
        end
    end
    wjminus=p2(wj);
    while (wjminus>0) && (h>0) && (alcnt(h)>0 || arcnt(h)>0) && (max([Alefts(h,1:alcnt(h)),Arights(h,1:arcnt(h))]) == wjminus )

        
        %remove wj-1 from the ALBh and ARBh list
        delw=[];
        for rr=1:alcnt(h)
            if Alefts(h,rr)==wjminus
                delw=[delw,rr];
                %Fix corresponding segments alpha position
%                 alpha(Elefts(h,rr))=1;
            end
        end
        temph=Alefts(h,1:alcnt(h));
        temph(delw)=[];
        Alefts(h,1:alcnt(h))=[temph,zeros(1,alcnt(h)-numel(temph))];
        alcnt(h)=numel(temph);
        delw=[];
        for rr=1:arcnt(h)
            if Arights(h,rr)==wjminus
                delw=[delw,rr];
%                 alpha(Erights(h,rr))=-1;
            end
        end
        temph=Arights(h,1:arcnt(h));
        temph(delw)=[];
        Arights(h,1:arcnt(h))=[temph,zeros(1,arcnt(h)-numel(temph))];
        arcnt(h)=numel(temph);
        if alcnt(h)==0 && arcnt(h)==0
%             Elefts(h,1:elcnt(h))
%             Erights(h,1:ercnt(h))
%             pause
            for rr=1:elcnt(h)
                alpha(Elefts(h,rr))=1;
                
            end
            for rr=1:ercnt(h)
                alpha(Erights(h,rr))=-1;
            end
            elcnt(h)=0;
            ercnt(h)=0;
            h=h-1;
        end
    end
end
%        Alefts(1:5,:)
%        disp('finallefts')
%        Arights(1:5,:)
%        disp('finalrights')
%         h


for ell=1:h
    if (alcnt(ell)>0 && max(Alefts(ell,1:alcnt(ell)))>=w1) && (arcnt(ell)>0 && max(Arights(ell,1:arcnt(ell)))>=w1)
        planar=0;
% Spinepath
% w0
% w1
  
%         Arights(ell,:)
%         e0
%         disp('exitplan2')
%         pause
        return;
    end
    if max(Arights(ell,1:arcnt(ell)))>=w1
        %then right is indside
        for rr=1:elcnt(ell)
            alpha(Elefts(ell,rr))=-1;
        end
        for rr=1:ercnt(ell)
            alpha(Erights(ell,rr))=1;
        end
    else
        for rr=1:elcnt(ell)
            alpha(Elefts(ell,rr))=1;
        end
        for rr=1:ercnt(ell)
            alpha(Erights(ell,rr))=-1;
        end
    end
    
    
    %concate L in some order (unknown atm)
    if alcnt(ell)>0 && max(Alefts(ell,1:alcnt(ell)))>=w1
        L = [L,Arights(ell,1:arcnt(ell)),Alefts(ell,1:alcnt(ell))];
    else
        L = [L,Alefts(ell,1:alcnt(ell)),Arights(ell,1:arcnt(ell))];
    end
    
end
lcnt=numel(L);
EL=e0*ones(1,lcnt);
end


