function [T,A,cyclic_adj] = embedding_given_alpha4(e0,t,alpha,cyclic_adj,newvadj,neweadj,M,deg,parent,backedge,newel)
%e is a pair of vertices(directed because we will be dealing with reversed
%edges too).

%find spine of the segment (recursive) of the given edge.
if backedge(e0)==0
    x=newel(e0,1);
    y=newel(e0,2);
else
    x=newel(e0,2);
    y=newel(e0,1);
end
Spinepath=[];
currv = y;
curre = e0;
scnt = 0;
if backedge(e0)==0
    for i=1:M
        if backedge(curre)==1
            w0 = currv;
            break;
        end
        scnt = scnt + 1;
        Spinepath(scnt) = currv;
        curre = neweadj(currv,1);
        currv = newvadj(currv,1);
    end
else
    w0 = y;
end

% total number of verts from wo,...,wk:

Tdash=[];
Adash=[];

% Lstartindex=0;
AL=[];
AR=[];
T=[];
T(1) = neweadj(Spinepath(scnt),1);

for j=scnt:-1:1
    wj=Spinepath(j);
    indices=2:deg(wj);
    
    for rr=indices
        ej=neweadj(wj,rr);
        if backedge(ej)==0
%             if alpha(ej)==0
%                 ej
%                 disp('alphaprob')
%             end
            if alpha(ej)==-1
                if t==-1
                    ta=1;
                else
                    ta=-1;
                end
            else
                if t==1
                    ta=1;
                else
                    ta=-1;
                end
            end
            [Tdash,Adash,cyclic_adj] = embedding_given_alpha4(ej,ta,alpha,cyclic_adj,newvadj,neweadj,M,deg,parent,backedge,newel);
        else
            Tdash = ej;
            Adash = ej;
        end

        if t == alpha(ej)
            T = [Tdash,T];
            AL = [AL,Adash];
        else
            T = [T,Tdash];
            AR = [Adash,AR];
        end
    end

        wjminus=parent(wj);

    for rr=1:deg(wjminus)
        if newvadj(wjminus,rr)==wj
            eminus=neweadj(wjminus,rr);
            break
        end
    end
    op = [eminus,T];
    cyclic_adj(wj,1:numel(op)) = op;

    TAR=[];
    TAL=[];
        for rr=1:numel(AL)
            if newel(AL(rr),1)==wjminus || newel(AL(rr),2)==wjminus
                TAL=[TAL,AL(rr)];
            end
        end
        for rr=1:numel(AR)
            if newel(AR(rr),1)==wjminus || newel(AR(rr),2)==wjminus
                TAR=[TAR,AR(rr)];
            end
        end
    T = [TAL,eminus,TAR];
end
A = [AR,neweadj(Spinepath(scnt),1),AL];

end

