function [ Sixidx,incidente,Clabel,Dlabel,Cidx,N,M,deglist ] = embed_plane_build( N,M,Sixidx,deglist,seed,draw,incidente,vadj,vidx,eadj )
d = zeros(N,1);
done = zeros(N,1);
v=ceil(rand*(N));
done(v) = 1;
totaldone = 1;
p = zeros(N,1);
looknext = zeros(N+1,1);
looknext(1) = v;
looknextcount = 1;
index = 1;
t=0;
while(looknext(index) ~= 0)
    v = looknext(index);
    for i=vidx(v)+1:vidx(v+1)
        if(done(vadj(i)) == 0)
            looknextcount = looknextcount + 1;
            looknext(looknextcount) = vadj(i);
            d(vadj(i)) = d(v) + 1;
            p(vadj(i)) = v;
            done(vadj(i)) = 1;
            totaldone = totaldone + 1;
        else
            if p(v)~=vadj(i)
            %we have found the first vertex returned to and v is the last
            %vertex on the cycle.
            t=1;
            break
            end
        end
    end
    if t
        break
    end
    index = index + 1;
end

if t==0
    %then acyclic
    return;
end

otherv=vadj(i);
dv1=d(v);
dv2=d(otherv);
% tv=zeros(dv1+dv2+1,1);
% tv(dv1+1)=v;

% for i=1:dv1
%     v=p(v);
%     tv(dv1+1-i)=v;
% end
% tv(dv1+2)=otherv;
% 
% for i=1:dv2-1
%     otherv=p(otherv);
%     tv(dv1+2+i)=otherv;
% end

%create current Sixidx by choosing an arbitrary orientation for this cycle.
% p(1)=tv(end);
checked=zeros(N,1);
checked(v) = 1;
checked(otherv) = 1;
f2=find(vadj(vidx(v)+1:vidx(v+1))==otherv);
eb1=eadj(vidx(v)+f2);
eb2 = eb1;
if dv1>dv2
    swt = 0;
else
    swt=1;
end
not_added_edges=ones(M,1);
not_added_edges(eb1)=0;
for i=1:dv1+dv2+1
    if swt == 0
        vb = v;
        v = p(v);
        swt = 1;
        f2=find(vadj(vidx(v)+1:vidx(v+1))==vb);
        ef1=eadj(vidx(v)+f2);
        not_added_edges(ef1)=0;
        if Sixidx(eb1,1)==vb
            Sixidx(eb1,3)=ef1;
            Sixidx(eb1,4)=ef1;
        else
            Sixidx(eb1,5)=ef1;
            Sixidx(eb1,6)=ef1;
        end
        if Sixidx(ef1,1)==vb
            Sixidx(ef1,3)=eb1;
            Sixidx(ef1,4)=eb1;
        else
            Sixidx(ef1,5)=eb1;
            Sixidx(ef1,6)=eb1;
        end
        eb1 = ef1;
        if checked(v)==0
            checked(v)=1;
        else
            break;
        end
    else
        vb = otherv;
        otherv = p(otherv);
        swt = 0;
        
        f2=find(vadj(vidx(otherv)+1:vidx(otherv+1))==vb);
        ef2=eadj(vidx(otherv)+f2);
        not_added_edges(ef2)=0;
        if Sixidx(eb2,1)==vb
            Sixidx(eb2,3)=ef2;
            Sixidx(eb2,4)=ef2;
        else
            Sixidx(eb2,5)=ef2;
            Sixidx(eb2,6)=ef2;
        end
        if Sixidx(ef2,1)==vb
            Sixidx(ef2,3)=eb2;
            Sixidx(ef2,4)=eb2;
        else
            Sixidx(ef2,5)=eb2;
            Sixidx(ef2,6)=eb2;
        end
        eb2 = ef2;
        if checked(otherv)==0
            checked(otherv)=1;
        else
            break;
        end
    end
end

%now v == otherv
if Sixidx(ef1,1)==v
    Sixidx(ef1,3)=ef2;
    Sixidx(ef1,4)=ef2;
else
    Sixidx(ef1,5)=ef2;
    Sixidx(ef1,6)=ef2;
end
if Sixidx(ef2,1)==v
    Sixidx(ef2,3)=ef1;
    Sixidx(ef2,4)=ef1;
else
    Sixidx(ef2,5)=ef1;
    Sixidx(ef2,6)=ef1;
end 

current_crossings=0;
Clabel=[];
Dlabel=[];
Cidx=zeros(M+1,1);
origN=N;
while 1
    vm=0;
    if seed
    verts=randperm(origN);
    else
        verts=1:origN;
    end
    for i=verts
        if checked(i)==1 %scanning currently added vertices for an edge which leaves the current graph.
            %then insert this vertex.
%             vidx
%             eadj
%             verts
%             i
            for j=vidx(i)+1:vidx(i+1)
                if not_added_edges(eadj(j))
                    if Sixidx(eadj(j),1)==i
                        vm=Sixidx(eadj(j),2);
                    else
                        vm=Sixidx(eadj(j),1);
                    end
                    checked(vm)=1;
                    break
                end
            end
            if vm>0
                break
            end
        end
    end
    if vm==0
        %then done
        break
    end

    [ Sixidx_plan,~,elist,eidx,~,M_plan,origedgelabel,origedgeorder,incidente_plan ] = Planarise_Sixidx_planarembedding( Sixidx,...
        Clabel,Cidx,Dlabel,N,M,not_added_edges);
    [F,Fidx,Fdir,dvadj,~,dualel,Nd,deadj]=Faces(Sixidx_plan,M_plan,find(not_added_edges),zeros(M_plan,1));
    
    %insert vertex into a new face, which is picked using shortest
    %distances.  fin vertices are now only those that already in
    %the current graph.
    d=0;
    fin=[];
    fi=[];
    for i=vidx(vm)+1:vidx(vm+1)
        if checked(vadj(i))
            d=d+1;
            fin(d,1)=vadj(i);
            fi(d,1)=eadj(i);
        end
    end

    [ newcross,pathedge,pathedgeonce,paths,pdist,treecheck,newface ] = Get_distances_planarembedding(dvadj,Fidx,Nd,Sixidx_plan,...
        dualel,d,fin,incidente_plan,deglist,deadj);
    current_crossings=current_crossings+newcross;
    %update Clabel,Sixidx, etc with the new vertex now in place.
    [ Sixidx,Clabel,Dlabel,Cidx ] = New_clabel_planarembedding( treecheck,pathedge,pathedgeonce,paths,Sixidx_plan,fin,fi,...
        Clabel,Dlabel,Cidx,F,Fdir,pdist,M,d,incidente,vm,elist,eidx,Fidx,M_plan,newface,Sixidx,origedgelabel,origedgeorder,1:Nd);
    not_added_edges(fi)=0;
    %and check for any subdivisions/edge rearrangements.
    [ current_crossings,Sixidx,Clabel,Dlabel,Cidx,N,M,incidente,deglist,not_added_edges,checked,vadj,eadj,vidx  ] = Subd_try_planarembedding( current_crossings,...
        Sixidx,Clabel,Dlabel,Cidx,pathedge,N,M,origedgelabel,incidente,deglist,pdist,fi,fin,vm,not_added_edges,checked,vadj,eadj,vidx );
end




end

