function [ Sixidx,incidente,Clabel,Dlabel,Cidx,N,M,deglist ] = embed_plane_build_incremental( N,M,Sixidx,deglist,seed,draw,incidente,vadj,vidx,eadj )
d = zeros(N,1);
done = zeros(N,1);
done(1) = 1;
totaldone = 1;
p = zeros(N,1);
looknext = zeros(N+1,1);
looknext(1) = 1;
looknextcount = 1;
index = 1;
t=0;
while(looknext(index) ~= 0)
    v = looknext(index);
    for i=vidx(v)+1:vidx(v+1)
        if(done(vadj(i)) == 0)
            looknextcount = looknextcount + 1;
            looknext(looknextcount) = vadj(i);
            d(vadj(i)) = d(v) + 1;
            p(vadj(i)) = v;
            done(vadj(i)) = 1;
            totaldone = totaldone + 1;
        else
            if p(v)~=vadj(i)
                %we have found the first vertex returned to and v is the last
                %vertex on the cycle.
                t=1;
                break
            end
        end
    end
    if t
        break
    end
    index = index + 1;
end

if t==0
    %then acyclic
    return;
end

otherv=vadj(i);
dv1=d(v);
dv2=d(otherv);
% tv=zeros(dv1+dv2+1,1);
% tv(dv1+1)=v;

% for i=1:dv1
%     v=p(v);
%     tv(dv1+1-i)=v;
% end
% tv(dv1+2)=otherv;
%
% for i=1:dv2-1
%     otherv=p(otherv);
%     tv(dv1+2+i)=otherv;
% end

%create current Sixidx by choosing an arbitrary orientation for this cycle.
% p(1)=tv(end);
checked=zeros(N,1);
checked(v) = 1;
checked(otherv) = 1;
f2=find(vadj(vidx(v)+1:vidx(v+1))==otherv);
eb1=eadj(vidx(v)+f2);
eb2 = eb1;
if dv1>dv2
    swt = 0;
else
    swt=1;
end
not_added_edges=ones(M,1);
not_added_edges(eb1)=0;
for i=1:dv1+dv2+1
    if swt == 0
        vb = v;
        v = p(v);
        swt = 1;
        f2=find(vadj(vidx(v)+1:vidx(v+1))==vb);
        ef1=eadj(vidx(v)+f2);
        not_added_edges(ef1)=0;
        if Sixidx(eb1,1)==vb
            Sixidx(eb1,3)=ef1;
            Sixidx(eb1,4)=ef1;
        else
            Sixidx(eb1,5)=ef1;
            Sixidx(eb1,6)=ef1;
        end
        if Sixidx(ef1,1)==vb
            Sixidx(ef1,3)=eb1;
            Sixidx(ef1,4)=eb1;
        else
            Sixidx(ef1,5)=eb1;
            Sixidx(ef1,6)=eb1;
        end
        eb1 = ef1;
        if checked(v)==0
            checked(v)=1;
        else
            break;
        end
    else
        vb = otherv;
        otherv = p(otherv);
        swt = 0;
        
        f2=find(vadj(vidx(otherv)+1:vidx(otherv+1))==vb);
        ef2=eadj(vidx(otherv)+f2);
        not_added_edges(ef2)=0;
        if Sixidx(eb2,1)==vb
            Sixidx(eb2,3)=ef2;
            Sixidx(eb2,4)=ef2;
        else
            Sixidx(eb2,5)=ef2;
            Sixidx(eb2,6)=ef2;
        end
        if Sixidx(ef2,1)==vb
            Sixidx(ef2,3)=eb2;
            Sixidx(ef2,4)=eb2;
        else
            Sixidx(ef2,5)=eb2;
            Sixidx(ef2,6)=eb2;
        end
        eb2 = ef2;
        if checked(otherv)==0
            checked(otherv)=1;
        else
            break;
        end
    end
end

%now v == otherv
if Sixidx(ef1,1)==v
    Sixidx(ef1,3)=ef2;
    Sixidx(ef1,4)=ef2;
else
    Sixidx(ef1,5)=ef2;
    Sixidx(ef1,6)=ef2;
end
if Sixidx(ef2,1)==v
    Sixidx(ef2,3)=ef1;
    Sixidx(ef2,4)=ef1;
else
    Sixidx(ef2,5)=ef1;
    Sixidx(ef2,6)=ef1;
end

current_crossings=0;
Clabel=[];
Dlabel=[];
Cidx=zeros(M+1,1);
origN=N;
while 1
    vm=0;
    if seed
        verts=randperm(origN);
    else
        verts=1:origN;
    end
    for i=verts
        if checked(i)==1 %scanning currently added vertices for an edge which leaves the current graph.
            %then insert this vertex.
            %             vidx
            %             eadj
            %             verts
            %             i
            for j=vidx(i)+1:vidx(i+1)
                if not_added_edges(eadj(j))
                    if Sixidx(eadj(j),1)==i
                        vm=Sixidx(eadj(j),2);
                    else
                        vm=Sixidx(eadj(j),1);
                    end
                    checked(vm)=1;
                    break
                end
            end
            if vm>0
                break
            end
        end
    end
    if vm==0
        %then done
        break
    end
    
    [ Sixidx_plan,~,elist,eidx,~,M_plan,origedgelabel,origedgeorder,incidente_plan ] = Planarise_Sixidx_planarembedding( Sixidx,...
        Clabel,Cidx,Dlabel,N,M,not_added_edges);
    
    [F,Fidx,Fdir,dvadj,~,dualel,Nd,deadj]=Faces(Sixidx_plan,M_plan,find(not_added_edges),zeros(M_plan,1));
    
    %insert vertex into a new face, which is picked using shortest
    %distances.  fin vertices are now only those that already in
    %the current graph.
    d=0;
    fin=[];
    fi=[];
    for i=vidx(vm)+1:vidx(vm+1)
        if checked(vadj(i))
            d=d+1;
            fin(d,1)=vadj(i);
            fi(d,1)=eadj(i);
        end
    end
    
    [ newcross,pathedge,pathedgeonce,paths,pdist,treecheck,newface ] = Get_distances_planarembedding(dvadj,Fidx,Nd,Sixidx_plan,...
        dualel,d,fin,incidente_plan,deglist,deadj);
    current_crossings=current_crossings+newcross;
    %update Clabel,Sixidx, etc with the new vertex now in place.
    [ Sixidx,Clabel,Dlabel,Cidx ] = New_clabel_planarembedding( treecheck,pathedge,pathedgeonce,paths,Sixidx_plan,fin,fi,...
        Clabel,Dlabel,Cidx,F,Fdir,pdist,M,d,incidente,vm,elist,eidx,Fidx,M_plan,newface,Sixidx,origedgelabel,origedgeorder,1:Nd);
    not_added_edges(fi)=0;
    %and check for any subdivisions/edge rearrangements.
    [ current_crossings,Sixidx,Clabel,Dlabel,Cidx,N,M,incidente,deglist,not_added_edges,checked,vadj,eadj,vidx  ] = Subd_try_planarembedding( current_crossings,...
        Sixidx,Clabel,Dlabel,Cidx,pathedge,N,M,origedgelabel,incidente,deglist,pdist,fi,fin,vm,not_added_edges,checked,vadj,eadj,vidx );
    Sixidx
    disp(['crossings before reins: ',num2str(current_crossings)]);
    pause
    if current_crossings>0
        ecnt=0;
        vcnt=0;
        el3=zeros(M,2);
        cl3=[];
        ci3=[];
        emap=zeros(M,1);
        vmap=zeros(N,1);
        for i=1:M
            if checked(Sixidx(i,1))==1 && checked(Sixidx(i,2))==1
                ecnt=ecnt+1;
                emap(i,1)=ecnt;
                if vmap(Sixidx(i,1))==0
                    vcnt=vcnt+1;
                    vmap(Sixidx(i,1),1)=vcnt;
                end
                if vmap(Sixidx(i,2))==0
                    vcnt=vcnt+1;
                    vmap(Sixidx(i,2),1)=vcnt;
                end
                el3(ecnt,1:2)=[vmap(Sixidx(i,1),1),vmap(Sixidx(i,2),1)];
            end
        end
        ccnt2=0;
        ci3=0;
        for i=1:ecnt
            oe=find(emap==i);
            for j=Cidx(oe)+1:Cidx(oe+1)
                ccnt2=ccnt2+1;
                cl3(ccnt2,1)=emap(Clabel(j));
            end
            ci3(i+1,1)=ccnt2;
        end
        el3=el3(1:ecnt,:);
        elM=size(el3,1);
        eldeg=zeros(elM,1);
        for i=1:elM
            eldeg(el3(i,1))=eldeg(el3(i,1))+1;
            eldeg(el3(i,2))=eldeg(el3(i,2))+1;
        end
        qd=find(eldeg==1);
        if length(qd)>0
            disp('deg 1s');
            pause
        end
        origcidx=ci3;
        M4=size(el3,1);
        Mdel1=size(el3,1);
        Ndel1=vcnt;
        origclab=cl3;
        elorig=el3;
        ccross=ci3(Mdel1+1)/2;
        planvlabels=zeros(ci3(M4+1),1);
        planedges=zeros(ci3(M4+1),1);
        elistorig=zeros(M4+origcidx(M4+1),1);
        eidxorig=[0;(1:M4)']+origcidx;
        elistorig(eidxorig(1:M4)+1)=1:M4;
        origedgelabel=[(1:M4)';zeros(origcidx(end),1)];
        origedgeorder=[ones(M4,1);zeros(origcidx(end),1)];
        el4=[elorig;zeros(origcidx(end),2)];
        for i=1:M4
            if origcidx(i+1)-origcidx(i)~=0
                tt=el4(i,2);
            end
            for j=1:origcidx(i+1)-origcidx(i)
                M4=M4+1;
                elistorig(eidxorig(i)+j+1)=M4;
                origedgelabel(M4)=i;
                origedgeorder(M4)=j+1;
                if planvlabels(origcidx(i)+j)==0
                    N=N+1;
                    planvlabels(origcidx(i)+j)=N;
                    ce=origclab(origcidx(i)+j);
                    f1=find(origclab(origcidx(ce)+1:origcidx(ce+1))==i);
                    planvlabels(origcidx(ce)+f1)=N;
                    planedges(N-Ndel1)=i;
                    planedges(N-Ndel1+ccross)=origclab(origcidx(i)+j);
                end
            end
            if origcidx(i+1)-origcidx(i)>0
                el4(M4,1:2)=[tt,planvlabels(origcidx(i+1))];
                el4(i,2)=planvlabels(origcidx(i)+1);
            end
            for j=1:origcidx(i+1)-origcidx(i)-1
                if planvlabels(origcidx(i)+j)<planvlabels(origcidx(i)+j+1)
                    el4(elistorig(eidxorig(i)+j+1),1)=planvlabels(origcidx(i)+j);
                    el4(elistorig(eidxorig(i)+j+1),2)=planvlabels(origcidx(i)+j+1);
                else
                    el4(elistorig(eidxorig(i)+j+1),1)=planvlabels(origcidx(i)+j+1);
                    el4(elistorig(eidxorig(i)+j+1),2)=planvlabels(origcidx(i)+j);
                end
            end
        end
        A4=el_to_adj(el4);
        el3
        is_planar(sparse(A4))
        disp('planar_checkA');
        pause
        checkdel=1;
        emap1=(1:ecnt)';
        vmap1=(1:vcnt)';
        while checkdel
                checkdel=0;
            for i=1:ecnt
                if eldeg(el3(i,1))==1
                    el3(i,:)=[];
                    emap1(i,1)=[];
                    vmap1(el3(i,1),1)=[];
                end
                if eldeg(el3(i,2))==1
                    el3(i,:)=[];
                    emap1(i,1)=[];
                    vmap1(el3(i,2),1)=[];
                end
            end           
        end
                
        
        
        [current_crossings, cl3, ci3] = Quick_cross( el3,4,2,0,0,cl3,ci3,[],[],0 );
        
        [Sixidx3]=Sixidx_given_clabel(el3,cl3,ci3);
        
        ccnt2=0;
        for i=1:M
            if checked(Sixidx(i,1))==1 && checked(Sixidx(i,2))==1
                ne=emap(i);
                for j=ci3(ne)+1:ci3(ne+1)
                    ccnt2=ccnt2+1;
                   Clabel(ccnt2,1)=find(emap==cl3(j));
                end
            end
            Cidx(i+1,1)=ccnt2;
        end
        Clabel=Clabel(1:length(cl3));
        for i=1:size(el3,1)
            oe=find(emap==i);
            va=find(vmap==el3(i,1));
            vb=find(vmap==el3(i,2));
            if va<vb
                for j=3:6
                    Sixidx(oe,j)=find(emap==Sixidx3(i,j));
                end
            else
                Sixidx(oe,3)=find(emap==Sixidx3(i,5));
                Sixidx(oe,4)=find(emap==Sixidx3(i,6));
                Sixidx(oe,5)=find(emap==Sixidx3(i,3));
                Sixidx(oe,6)=find(emap==Sixidx3(i,4));
            end
        end
        disp(['crossings after reins: ',num2str(current_crossings)]);
        pause
    end
    
end




end

