function [ newf,newfidx,newdir,rf_map ] = find_merge_faces( Nd,F,Fdir,Fidx,dualel,bad_edges,paths,pdist,d,oldNd,pooledgemap)
%the faces of paths matrix now tell us which faces are actually going to be
%used in the update.
cnt3=0;
%grab relavent faces and scan around, making combined faces. Else add
%unmerged face to new face vector.
newfnum=0;
newf=zeros(Fidx(end),1);
newdir=zeros(Fidx(end),1);
newfidx=zeros(Nd,1);
rf_map=zeros(max(max(paths)),1);
%but fi edges are not going to be considered, in order to keep edges
%as same index.
  
for i=1:d
    for j=1:pdist(i)+1 %number of faces on path
        if rf_map(paths(i,j))==0
            if paths(i,j)<=oldNd
                %then face is one of the original faces and there are no bad
                %edges involved.
                newfnum=newfnum+1;
                newfidx(newfnum)=cnt3;
                rf_map(paths(i,j))=newfnum;
                f=paths(i,j);
                newf(cnt3+1:(cnt3+Fidx(f+1)-Fidx(f)))=F(Fidx(f)+1:Fidx(f+1));
                newdir(cnt3+1:(cnt3+Fidx(f+1)-Fidx(f)))=Fdir(Fidx(f)+1:Fidx(f+1));
                cnt3=cnt3+Fidx(f+1)-Fidx(f);
                
            else
                %then start a merged face scan.
                
                newfnum=newfnum+1;
                rf_map(paths(i,j))=newfnum;
%                 cnt2=1;
                currf=pooledgemap(paths(i,j)-oldNd);
                %find an appropriate starting edge
%                 F(Fidx(currf)+cnt2)
%                 numel(bad_edges)
%                 while bad_edges(F(Fidx(currf)+cnt2))
%                     cnt2=cnt2+1;
%                     if cnt2 == Fidx(currf+1)- Fidx(currf)
%                         %then swap to next face to look
%                         if dualel(F(Fidx(currf)+cnt2),1) == currf
%                             currf = dualel(F(Fidx(currf)+cnt2),2);
%                         else
%                             currf = dualel(F(Fidx(currf)+cnt2),1);
%                         end
%                         cnt2 = 1;
%                     end   
%                 end
                %first edge of face
%                 if pdist(i)>0
%                     if j ~= pdist(i)+1
%                         starte=pathedge(i,j);
%                         if rel_chk(dualel(starte,1)) == paths(i,j)
%                             startd = -1;
%                         else
%                             startd = 1;
%                         end
% 
%                     else
%                         starte=pathedge(i,j-1);
%                         if rel_chk(dualel(starte,1)) == paths(i,j)
%                             startd = 1;
%                         else
%                             startd = -1;
%                         end
%                     end
%                 else
%                     starte = incidente(fin(i));
%                     while 1
%                             if dualel(starte,1)==paths(i,j)
%                                 if Sixidx_plan(starte,1) == fin(i)
%                                     startd = 1;
%                                 else
%                                     startd = -1;
%                                 end
%                                 break;
%                             end
%                             if dualel(starte,2)==paths(i,j)
%                                 if Sixidx_plan(starte,1) == fin(i)
%                                     startd = -1;
%                                 else
%                                     startd = 1;
%                                 end
%                                 break;
%                             end
%                         if Sixidx_plan(starte,1) == fin(i)
%                            starte = Sixidx_plan(starte,3); 
%                         else
%                             starte = Sixidx_plan(starte,5);
%                         end
%                     end
%                 end
                stackmax = 10;
                stack = zeros(stackmax,1);
                stack(1) = currf;
                stackpos = 1;
                stackcount = 0;
                t = 1;
                while t
                    stackcount = stackcount+1;
                    currf = stack(stackcount);
                    for k=Fidx(currf)+1:Fidx(currf+1)
                        if bad_edges(F(k))==1
                            %add other face onto stack
                            stackpos = stackpos+1;
                            if stackpos > stackmax
                                stack = [stack;zeros(stackmax,1)];
                                stackmax = 2*stackmax;
                            end
                            if dualel(F(k),1)==currf
                                stack(stackpos) = dualel(F(k),2);
                            else
                                stack(stackpos) = dualel(F(k),1);
                            end
                            
                        else
                            starte = F(k);
                            startd = Fdir(k);
                            cnt2 = k - Fidx(currf);
                            t = 0;
                            break;
                        end
                    end
                end
                
%                     disp('stack')
%                 stack(1:stackpos)'
%                  [starte,startd,cnt2,stack(1:stackpos)']
%                 startd 
%                 currf
%                 F(Fidx(currf)+1:Fidx(currf+1))
%                 bad_edges(F(Fidx(currf)+1:Fidx(currf+1)))
%                 pause
                
                
                
%                  startd=Fdir(Fidx(currf)+cnt2);
                newfidx(newfnum)=cnt3;
                 cnt3=cnt3+1;
                
                 newf(cnt3)=starte;
                 newdir(cnt3)=startd;
                while 1
%                     newf(1:cnt3)'
                    if cnt2==Fidx(currf+1)-Fidx(currf)
                        cnt2=1;
                    else
                        cnt2=cnt2+1;
                    end
                    curre=F(Fidx(currf)+cnt2);
                    currd=Fdir(Fidx(currf)+cnt2);
                    if bad_edges(curre)==1
%                         curre
                        currd=-currd;
                        %and swap face (if not pendant edge)
                        if dualel(curre,1)~=dualel(curre,2)
                            %then non pendant edge
                            if currf==dualel(curre,1)
                                
                                currf=dualel(curre,2);
                            else
                             
                                currf=dualel(curre,1);
                            end
                            cnt2=find(F(Fidx(currf)+1:Fidx(currf+1))==curre);
                        else
                            
                            cnt4=find(F(Fidx(currf)+1:Fidx(currf+1))==curre);
                            %then we also need to find the right position.
                            for k=[1 2]
                                if Fdir(Fidx(currf)+cnt4(k))~=currd
                                    cnt2=cnt4(k);
                                    break
                                end
                            end
                        end
                        continue
                   
               
                    end
                    %else save info and start edges if first time we are
                    %not at a bad edge.
%                     if starte == 0
%                         starte=F(Fidx(currf)+cnt2);
%                         startd=Fdir(Fidx(currf)+cnt2);
%                         cnt3=cnt3+1;
%                         newf(cnt3)=starte;
%                         newdir(cnt3)=startd;
%                     else
                        %or break if back to the beginning edge.
                        if curre==starte && currd==startd
                            %then finished
                            newfidx(newfnum+1)=cnt3;
                            break
                        end
                        cnt3=cnt3+1;
                        newf(cnt3)=curre;
                        newdir(cnt3)=currd;
%                     end
                end
%                 newf(newfidx(newfnum)+1:newfidx(newfnum+1))'
%                 pause
            end
        end
    end
end

newfidx(newfnum+1)=cnt3;















end

